--event engine
player = {
--positioning
x = 10*tile.w,--player actual co-ordinate
grid_x = 10*tile.w,--next grid to move
y = 10*tile.h,
grid_y = 10*tile.h,
u_n=0;u_e=0;u_s=0;u_w=0;f_x=0;f_y=0;
--size
w = tile.w ; h = tile.h;
--possible direction
north = true ; east = true ; south = true ; west = true;
--physics 
xspeed = 8; yspeed = 8; --multiple of tile
xvel = 0 ; yvel = 0;
--other
move = false,
control = {right = false;left = false;down = false;up = false}
}

function love.keypressed(key,isrepeat)
--player controls
    if (key == "right" or key == "d") then
        player.control.right = true
    elseif (key == "left" or key == "a") then
        player.control.left = true
    elseif (key == "up" or key == "w") then
        player.control.up = true
    elseif (key == "down" or key == "s") then
        player.control.down = true	
    end
end

function love.keyreleased(key)
--player controls
    if (key == "right" or key == "d") then
        player.control.right = false
    elseif (key == "left" or key == "a") then
        player.control.left = false
    elseif (key == "up" or key == "w") then
        player.control.up = false
    elseif (key == "down" or key == "s") then
        player.control.down = false	
    end
end

function player_nextgrid(map)
--calculate next tile when on grid
    if grid_check(player.x,player.y,player.grid_x,player.grid_y) then
        if player.control.right and (player.east and checktile(player.x,player.y,1,0)) then
		    --set next grid ahead only when key_pressed
            player.grid_x = math.floor(player.x) + tile.w 			
        elseif player.control.left and (player.west and checktile(player.x,player.y,-1,0)) then
            player.grid_x = math.floor(player.x) - tile.w 			
        elseif player.control.up and (player.north and checktile(player.x,player.y,0,-1)) then
            player.grid_y = math.floor(player.y) - tile.h			
        elseif player.control.down and (player.south and checktile(player.x,player.y,0,1)) then
            player.grid_y = math.floor(player.y) + tile.h			
        end
        --calculate velocity
        player.xvel = (math.floor(player.grid_x) - math.floor(player.x))/tile.w --set x vel
        player.yvel = (math.floor(player.grid_y) - math.floor(player.y))/tile.h --set y vel
    end
end

function player_motion(dt)
--check velocity direction then move
    if (math.floor(player.xvel) == -1) then --west -
        player.x = player.x - player.xspeed
    elseif (math.ceil(player.xvel) == 1) then --east +
        player.x = player.x + player.xspeed
    elseif (math.floor(player.yvel) == -1) then --north -
        player.y = player.y - player.yspeed
    elseif (math.ceil(player.yvel) == 1) then --south +
        player.y = player.y + player.yspeed
    end
end

function grid_check(event_x,event_y,grid_x,grid_y)
--checks if player is on grid math.floor to check with interger
    if math.floor(event_x) == math.floor(grid_x) and math.floor(event_y) == math.floor(grid_y) then
    return true
    end
    return false
end

function dir_nest(event_x,event_y)
local n,e,s,w
	n = math.floor(event_y) - tile.h --north -
	e = math.floor(event_x) + tile.w --east +
	s = math.floor(event_y) + tile.h --south +
	w = math.floor(event_x) - tile.w --west -
	return n,e,s,w
end

function fixed_floor(event_x,event_y)
local floor_x,floor_y
	floor_x = math.floor(event_x) --y
	floor_y = math.floor(event_y) --x
	return floor_x,floor_y
end

function player_bounds(map) --brute force if statements
	if not withmap(player.u_n,player.f_x,map) then
        player.north = false--north out of bounds
	end
	if not withmap(player.f_y,player.u_e,map) then
	    player.east = false--east out of bounds
	end
	if not withmap(player.u_s,player.f_x,map) then
	    player.south = false--south out of bounds
	end
	if not withmap(player.f_y,player.u_w,map) then
	    player.west = false--west out of bounds
	end
	if withmap(player.u_n,player.f_x,map) then
        player.north = true--north with bounds
	end
	if withmap(player.f_y,player.u_e,map) then
	    player.east = true--east with bounds
	end
	if withmap(player.u_s,player.f_x,map) then
	    player.south = true--south with bounds
	end
	if withmap(player.f_y,player.u_w,map) then
	    player.west = true--west with bounds
	end
end
